/**************************************************************************************************
 *
 *
 **************************************************************************************************/
/**************************************************************************************************
 *
 * 底层增强代码区域
 *
 **************************************************************************************************/
;
(function ($GLOBAL) {
    /**
     * 静态全局对象
     */
    this.$window = $(window);
    this.$document = $(document);
    this.$body = $('body');
    /**
     * 常用类型检测
     */
    this.isDef = function (obj) {
        return (typeof (obj) != 'undefined');
    };
    this.isStr = function (obj) {
        return (typeof (obj) == 'string');
    };
    this.isNum = function (obj) {
        return (typeof (obj) == 'number');
    };
    this.isFunc = function (obj) {
        return (typeof (obj) == 'function');
    };
    this.isArr = function (obj) {
        return Object.prototype.toString.call(obj) === '[object Array]';
    };
    this.isObj = function (obj) {
        return (typeof (obj) == 'object') && !isArr(obj);
    };
    /**
     * 原子对象
     */
    this.atom = function (obj) {
        return obj || {};
    };
    /**
     * 执行代理
     */
    this.proxy = function (exec, ctx) {
        return function () {
            exec.aplly(ctx || null, arguments);
        };
    };
    /**
     * 自适应的调试输出
     */
    this.cout = function (obj) {
        console ? console.info(obj) : alert(obj);
    };
    /**
     * 获取UNIX时间戳（毫秒）
     */
    this.time = function () {
        return new Date().getTime();
    };
    /**
     * 获取一个(m,n)之间的随机数
     */
    this.random = function (min, max, format) {
        var min = min || 0,
            max = max || 1,
            format = format || 'raw';
        return format == 'raw' ? (max - min) * Math.random() + min : Math[format]((max - min) * Math.random() + min);
    };
    /**
     * 深拷贝
     * @param obj
     */
    this.clone = function (obj) {
        return $.extend(true, {}, obj);
    };
    /**
     * 页面配置功能
     */
    this.$CONF = {};
    /**
     * Config读写
     */
    this.Config = function () {
        if (isStr(arguments[0])) return arguments.length > 1 ? ($CONF[arguments[0]] = arguments[1]) : $CONF[arguments[0]];
        if (isObj(arguments[0]) && arguments.length == 1) {
            for (var o in arguments[0]) {
                $CONF[o] = arguments[0][o];
            }
        }
    };
    /**
     * 页面缓存功能
     */
    this.$CACHE = {};
    /**
     * Cache读写
     */
    this.Cache = function () {
        if (isStr(arguments[0])) return arguments.length > 1 ? ($CACHE[arguments[0]] = arguments[1]) : $CACHE[arguments[0]];
        if (isObj(arguments[0]) && arguments.length == 1) {
            for (var o in arguments[0]) {
                $CACHE[o] = arguments[0][o];
            }
        }
    };
    /**
     * 删除指定Cache键值
     * @param key
     */
    this.removeCache = function (key) {
        delete $CACHE[key];
    };
    /**
     * 将指定Cache键值置为空
     * @param key
     */
    this.clearCache = function (key) {
        arguments.length ? ($CACHE[key] = null) : ($CACHE = {});
    };
    /**
     * 判断是否存在指定的键值
     * @param key
     * @returns {boolean}
     */
    this.existCache = function (key) {
        return key in $CACHE;
    };
    /**
     * cookie操作
     * @param key
     * @param value
     * @param options
     * @returns {*}
     */
    this.Cookie = function (key, value, expires) {
        var arr, expires = expires || 0, now = new Date();
        if (arguments.length > 1) {
            now.setTime(now.getTime() + expires * 24 * 60 * 60 * 1000);
            document.cookie = key + "=" + encodeURIComponent(value) + ";expires=" + now.toUTCString();
        }
        return (arr = document.cookie.match(new RegExp("(^| )" + key + "=([^;]*)(;|$)"))) ? decodeURIComponent(arr[2]) : null;
    };
    /**
     * 删除cookie
     * @param key
     */
    this.delCookie = function (key) {
        var now = new Date();
        now.setTime(now.getTime() - 1);
        if (Cookie(key) != null) document.cookie = key + "=;expires=" + now.toUTCString();
    };
    /**
     * 判断是否存在指定cookie
     * @param key
     * @returns {boolean}
     */
    this.existCookie = function (key) {
        return isStr(Cookie(key)) && (Cookie(key) != '');
    };
    /**
     * 操作功能容器
     */
    this.Cache('ACTION', { __hash_actions__: {} });
    this.Action = function () {
        if (arguments.length == 1) {
            if (isStr(arguments[0])) return Cache('ACTION')[arguments[0]];
            if (isObj(arguments[0])) {
                for (var o in arguments[0]) {
                    Cache('ACTION')[o] = arguments[0][o];
                }
            }
        }
        if (arguments.length > 1) Cache('ACTION')[arguments[0]] = arguments[1];
        if (arguments[2]) Cache('ACTION').__hash_actions__[arguments[0]] = arguments[1];
    };
    /**
     * AjaxTemplate容器
     */
    this.Cache('AJAXTEMPLATE', {});
    this.AjaxTemplate = function () {
        if (isStr(arguments[0])) return arguments.length > 1 ? (Cache('AJAXTEMPLATE')[arguments[0]] = arguments[1]) : Cache('AJAXTEMPLATE')[arguments[0]];
        if (isObj(arguments[0]) && arguments.length == 1) {
            for (var o in arguments[0]) {
                Cache('AJAXTEMPLATE')[o] = arguments[0][o];
            }
        }
    };
    /**
     * 类容器
     */
    this.Cache('CLASSES', {});
    this.Cache('OBJECTS', { __get__: {} });
    /**
     * 为UIComponent对象特别设置的通过id访问对象的方法
     * @param id 指定元素的ID
     * @returns {Object} 返回这个元素对应的实际对象实例
     */
    this.$$ = function (id) {
        return Cache('OBJECTS').__get__[$('#' + id).attr('instance-id')];
    };
    /**
     * 通过instance-id访问对象的方法
     * @param instanceId 指定元素的instance-id
     * @returns {Object} 返回这个元素对应的实际对象实例
     */
    this.$$$ = function (instanceId) {
        return Cache('OBJECTS').__get__[instanceId];
    };
    /**
     * 类和继承的实现
     * @param name 指定的类名称，可以直接new这个类名称，以创建实例
     * @param definition 类的定义
     * @returns {Function} 返回通用构造函数，包含这个类定义时的闭包环境，不建议使用！
     * @constructor
     */
    this.Class = function (name, definition, parent) {
        Cache('CLASSES')[name] = { __definition__: definition };
        var _CLASS = $GLOBAL[name] = function () {
            var exclusiveness = arguments[0] != 'EXTENDS' && this.__class_name__ == name;
            if (exclusiveness) {
                if (!Cache('OBJECTS')[name]) Cache('OBJECTS')[name] = [];
                this.__instance_id__ = name + '-' + Cache('OBJECTS')[name].length;
                Cache('OBJECTS')[name].push(this);
                Cache('OBJECTS').__get__[this.__instance_id__] = this;
            }
            parent && $GLOBAL[parent].apply(this, Cache('CLASSES')[name].__definition__[parent]);
            for (var m in definition) {
                if (m != name && m != parent && !isFunc(definition[m])) this[m] = definition[m];
            }
            isFunc(definition[name]) && definition[name].apply(this, arguments[0] == 'EXTENDS' ? Cache('CLASSES')[arguments[1]].__definition__[name] : arguments);
            if (exclusiveness) {
                var _this = this;
                (function (c) {
                    Cache('CLASSES')[c].__definition__.afterInitialize && Cache('CLASSES')[c].__definition__.afterInitialize.call(_this);
                    if (Cache('CLASSES')[c].__parent__) arguments.callee(Cache('CLASSES')[c].__parent__);
                })(this.__class_name__);
            }
        };
        if (parent) {
            if (!(Cache('CLASSES')[parent].__children__)) Cache('CLASSES')[parent].__children__ = [];
            Cache('CLASSES')[parent].__children__.push(name);
            Cache('CLASSES')[name].__parent__ = parent;
            _CLASS.prototype = new $GLOBAL[parent]('EXTENDS', name);
        }
        _CLASS.prototype.constructor = _CLASS;
        for (var f in definition) {
            if (f != name && f != 'afterInitialize' && isFunc(definition[f]) && !isFunc(_CLASS.prototype[f])) _CLASS.prototype[f] = definition[f];
        }
        _CLASS.prototype.__class_name__ = name;
        return _CLASS;
    };
    /*******************************************************************************************************************
     *
     * TODO:
     * 在这里添加全局方法/容器
     * 注意：不要在这里写与业务有关的功能！
     *
     ******************************************************************************************************************/
    /**
     * 触发无关点击事件控件容器
     */
    this.Cache('RELEVANT_CLICK_COMPONENT', []);
    /**
     * 注册无关点击事件对象
     */
    this.regRelevantClick = function ($intercepter) {
        $intercepter.attr('relevant-click-intercepter', Cache('RELEVANT_CLICK_COMPONENT').length);
        Cache('RELEVANT_CLICK_COMPONENT').push($intercepter);
    };
    /**
     * GET方法传递参数的容器
     */
    this.Cache('URL_ARGUMENTS', {});
    /**
     * 获取url中以GET方式传递的参数
     */
    this.GET = function () {
        if (arguments.length) {
            if (arguments[0] in Cache('URL_ARGUMENTS')) {
                return Cache('URL_ARGUMENTS')[arguments[0]];
            }
            else {
                throw '"' + arguments[0] + '"参数不存在！';
            }
        } else {
            return Cache('URL_ARGUMENTS');
        }
    };
    /**
     * 上传控件容器
     */
    this.Cache('FILE_UPLOADER', {});
    /**
     * 日期相关（似乎不是必须的，可以使用系统自带的）
     */
    this.toDoubleDigits = function (number) {
        return number < 10 ? '0' + number : number;
    };
    this.formatDate = function (timestamp) {
        return timestamp.getFullYear() + "年" + toDoubleDigits(timestamp.getMonth() + 1) + "月" + toDoubleDigits(timestamp.getDate()) + "日";
    };
    this.formatDateTime = function (timestamp) {
        return formatDate(timestamp) + " " + toDoubleDigits(timestamp.getHours()) + ":" + toDoubleDigits(timestamp.getMinutes()) + ":" + toDoubleDigits(timestamp.getSeconds());
    };
    this.formatDateServer = function (timestamp) {
        return timestamp.getFullYear() + "-" + toDoubleDigits(timestamp.getMonth() + 1) + "-" + toDoubleDigits(timestamp.getDate());
    };
    this.formatDateTimeServer = function (timestamp) {
        return formatDateServer(timestamp) + " " + toDoubleDigits(timestamp.getHours()) + ":" + toDoubleDigits(timestamp.getMinutes()) + ":" + toDoubleDigits(timestamp.getSeconds());
    };
})(this);
/***********************************************************************************************************************
 *
 * jQuery扩展代码区域
 *
 **********************************************************************************************************************/
$.extend({
    /**
     * 判断一个元素是否存在于一个数组中。
     * 若存在，第一个值是元素在数组中的位置，否则返回-1
     */
    inArray: function (value, array) {
        if ($.isArray(array)) {
            for (var i = 0, l = array.length; i < l; i++) {
                if (value == array[i]) return i;
            }
        }
        return -1;
    }
    /**
     * TODO:
     * 在这里扩展jQuery全局方法
     */
});
$.fn.extend({
    /**
     * 获取元素本身html代码的方法
     */
    selfHtml: function () {
        return $('<div></div>').append($(this).clone(false)).html();
    }
    /**
     * TODO:
     * 在这里扩展jQuery对象方法
     */
});
/***********************************************************************************************************************
 *
 * 配置区域
 * TODO:
 * 在这里进行页面配置定义
 *
 **********************************************************************************************************************/
Config('name', $body.attr('id'));
Config('file_upload_service_url', '/system/fileUpload.do');
Config('file_upload_service_url_image', '/system/uploadMsgImg.do');
/***********************************************************************************************************************
 *
 * 类定义代码区域
 * TODO:
 * 在这里进行类定义
 *
 **********************************************************************************************************************/
Class('Request', {
    Request: function (options) {
        options.type = options.type || 'POST';
        options.dataType = options.dataType || 'json';
        if (Config('ajax_debug_mode')) {
            if (AjaxTemplate(options.url)) {
                options.success.call(window, AjaxTemplate(options.url)(options.data || {}));
            } else {
                throw 'error:未定义AJAX接口返回数据模板！[ajax-template-name:"' + options.url + '"]';
            }
        } else {
            $.ajax(options);
        }
    }
});
/**
 * UIComponent类
 * 所有页面原件的基类
 */
Class('UIComponent', {
    name: '',
    __self__: null,
    appendTo: function (parent) {
        parent.append(this._self);
    },
    insertAfter: function (previous) {
        this.__self__.insertAfter(previous);
    },
    self: function () {
        return this.__self__;
    },
    UIComponent: function () {
    },
    afterInitialize: function () {
        this.name != this.__instance_id__ && this.__self__.attr('id', this.name);
        this.__self__.attr('instance-id', this.__instance_id__);
    }
});
/**
 * DataGrid类
 * 数据表格
 */
Class('DataGrid', {
    data: {},
    settings: {},
    table: null,
    thead: null,
    tbody: null,
    pageCtrl: null,
    selrow:0,
    generateRow: function (row_index, row_data) {
        var $tr = $('<tr></tr>').attr('row-index', row_index + 1), CO = this.settings.COLUMNS_ORDER, CD = this.settings.COLUMNS_DISPLAY, CW = this.settings.COLUMNS_WIDTH;
        if (this.selrow == row_index)
            $(this).css('backgroundColor', '#ffffff');
        else if (row_index % 2 != 0)
            $tr.css('background', "#f0f6fd");
        $(CO).each(function (col_index, col_name) {
           
            var $td = $('<td></td>').html(row_data[col_name]).appendTo($tr);
            CD && CD[col_name] && CD[col_name].call($td, row_data, col_index, row_index);
            $td.attr('col-name', col_name).attr('r', row_index + 1).attr('c', col_index + 1);
            CW && CW[col_name] && $td.css('width', CW[col_name]);
        });
      
        this.tbody.find('tbody').append($tr);
		$tr.mouseover(function(){
		    $(this).css('backgroundColor', '#d6e8fa');
		}).mouseout(function () {
		    //window.alert(this.selrow);
		    if (this.selrow == $(this).index())
		        $(this).css('backgroundColor', '#ffffff');
            else if($(this).index()%2 != 0){
                $(this).css('backgroundColor', '#f0f6fd');
            }else{
                $(this).css('backgroundColor','#fff');
            }
        });
	},
    generateHead: function () {
        var gen_this=this.settings.SORT_CTRL;
        var $thead = this.thead.find('tr').html(''), CO = this.settings.COLUMNS_ORDER, CC = this.settings.COLUMNS_CAPTION, CW = this.settings.COLUMNS_WIDTH;
        //var $thead2 = this.tbody.find('tr').html('');
        $(CO).each(function (col_index, col_name) {
            if (gen_this) {
                if (CC[col_name] && CC[col_name].indexOf('<input') > -1) $th = $('<th></th>').append(CC[col_name]).attr('col-name', col_name).attr('col-index', col_index + 1).appendTo($thead);
                else $th = $('<th href="#sort"></th>').append('<a href="#sort" class="fa"></a>' + CC[col_name]).attr('col-name', col_name).attr('col-index', col_index + 1).appendTo($thead);
            } else {
                var $th = $('<th></th>').html(CC[col_name]).attr('col-name', col_name).attr('col-index', col_index + 1).appendTo($thead);//before 3.24
            }
            // var $th2 = $('<th></th>').html(CC[col_name]).attr('col-name', col_name).attr('col-index', col_index + 1).appendTo($thead2);
            CW && CW[col_name] && $th.css('width', CW[col_name]);
            //CW && CW[col_name] && $th2.css('width', CW[col_name]);
        });
    },
    generateBody: function () {
        var _this = this;
        this.tbody.find('tbody').html('');
        $(this.data.rows).each(function (row_index, row_data) {
            _this.generateRow(row_index, row_data);
        });
    },
    reload: function (data) {
        var keywords = "";
        this.tbody.find('tbody').find("input:checked").each(function () {
                 keywords += $(this).attr("data-id") + ","; //获取被选中的值
             });
            keywords = keywords.substr(0, keywords.length - 1);
        this.data = data || {};
        this.generateHead();
        this.generateBody();
        var count = 0;
        this.tbody.find('tbody').find("input[type=checkbox]").each(function () {
            var selArr = keywords.split(',');
            var check_this = $(this);
            for (var i = 0; i < selArr.length; i++)
            {
                if ($(this).attr("data-id") == selArr[i]) {
                    check_this.attr("checked", true);
                    count++;
                }
            }
        });
        if (this.tbody.find('tbody').find("input[type=checkbox]").length == keywords.split(',').length)
        this.thead.find('input[type=checkbox]:first').prop('checked', true)
        //排序图标展示  3.24 add
        if (this.settings.SORT_CTRL) {
            if (this.pageCtrl.sortName) {
                var th = this.thead.find('th[col-name="' + this.pageCtrl.sortName + '"]'), sorta = null;
                if (th && th.length > 0) {
                    sorta = th.find('.fa');
                    if (this.pageCtrl.sortType == 'desc') sorta.attr('class', 'fa fa-sort-desc');
                    else sorta.attr('class', 'fa fa-sort-asc');
                }
            }
        }
        this.settings.NEED_PAGE_CTRL && this.pageCtrl && this.pageCtrl.reload({
            page: data.page,
            totalResults: data.totalResults
        });
    },
    render: function ($container) {
        if ($container) {
            $container.replaceWith(this.table);
            this.table.html((this.thead)).append((this.tbody));
            this.settings.NEED_PAGE_CTRL && this.pageCtrl.render(this.table);
        }
    },
    DataGrid: function (name, data, $container) {
        this.settings = Config(name) || {};
        this.table = $('<div style="min-width: 60%; overflow-x: auto;"></div>');
        this.thead = $('<div class="THEAD"><table class="table table-striped table-success"><thead><tr></tr></thead></table></div>');
        this.tbody = $('<div class="TBODY" style="overflow-y:auto;overflow-x: hidden;" ><table class="table table-striped table-success"><!--<thead><tr></tr></thead>--><tbody></tbody></table></divs>');
        if (this.settings.NEED_PAGE_CTRL) {
            this.pageCtrl = new PageCtrl(null, {
                bindTarget: this,
                page: data.page,
                totalResults: data.totalResults,
                pageSize: this.settings.PAGE_SIZE,
                pageSizes: this.settings.PAGE_SIZES,
                pageChangedAction: this.settings.PAGE_CHANGED_ACTION,
                pageSelectAction: this.settings.PAGE_SELECT_ACTION
            });
        }
        this.reload(data);
        $container && this.render($container);
        this.name = name || this.__instance_id__;
        this.__self__ = this.table;
    }
}, 'UIComponent');
/**
 * PageCtrl类
 * 分页器
 */
Class('PageCtrl', {
    bindTarget: null,
    page: 1,
    totalResults: 0,
    pageSize: null,
    maxPage: 1,
    pageSizes: null,
    pageChangedAction: null,
    pageSelectAction: null,
    pageCtrl: null,
    pager: null,
    sortType: 'desc',//D：倒序,U：顺序 3.24 add
    sortName: '',//排序列名
    pageSizeSwitcher: null,
    getNumbers: function () {
        var current = this.page, max = this.maxPage;
        if (max < 3) {
            var nums = [];
            for (var i = 0; i < max; i++) nums.push(i + 1);
            return nums;
        } else {
            return (current < 3) ? [1, 2, 3] : ((current > max - 1) ? [max - 2, max - 1, max] : [current - 1, current, current + 1]);
        }
    },
    generatePager: function () {
        var current = this.page, max = this.maxPage, $numArea = this.pager.find('div'), numhl = [];
        var $front = this.pager.find('.front').attr('page-num', 1);
        var $prev = this.pager.find('.prev').attr('page-num', current - 1);
        var $next = this.pager.find('.next').attr('page-num', current + 1);
        var $end = this.pager.find('.end').attr('page-num', max);
        //max > 3 && current > 3 && $numArea.append( '<i>...</i>' );
        $(this.getNumbers()).each(function () {
            numhl.push('<a' + (this == current ? ' class="current"' : ' href="#page-num"') + ' page-num="' + this + '">' + this + '</a>');
        });
        max > 3 && current < max - 1 && numhl.push('<i>...</i>');
        $numArea.html(numhl.join(''));
        current != 1 ? $front.attr('href', '#page-num').removeClass('disable') : $front.removeAttr('href').addClass('disable');
        current > 1 ? $prev.attr('href', '#page-num').removeClass('disable') : $prev.removeAttr('href').addClass('disable');
        current < max ? $next.attr('href', '#page-num').removeClass('disable') : $next.removeAttr('href').addClass('disable');
        current != max ? $end.attr('href', '#page-num').removeClass('disable') : $end.removeAttr('href').addClass('disable');
        this.pager.find('span b').text(max);
    },
    generatePageSizeSwitcher: function () {
        var _this = this, shl = [], $pageSelect = this.pageSizeSwitcher.find('select');
        if ($pageSelect.children('option').length > 0) return true;
        $(this.pageSizes).each(function () {
            shl.push('<option' + (this == _this.pageSize ? ' selected="selected">' : '>') + this + '</option>');
        });
        $pageSelect.html(shl.join(''));
    },
    reload: function (data) {
        this.page = data.page || this.page;
        this.totalResults = data.totalResults || this.totalResults;
        this.pageSize = data.pageSize || this.pageSize;
        this.maxPage = Math.ceil(this.totalResults / this.pageSize);
        this.pageSizes = data.pageSizes || this.pageSizes;
        this.pageSize && this.pageSizes && this.pageSizes.length && this.generatePageSizeSwitcher();
        var that = this;
        setTimeout(function(){
            that.generatePager();
        },300);
    },
    render: function ($bindTarget) {
        this.pageCtrl.html(this.pager);
        this.pageSize && this.pageSizes && this.pageSizes.length && this.pageCtrl.prepend(this.pageSizeSwitcher);
        this.pageCtrl.insertAfter($bindTarget);
    },
    PageCtrl: function (name, data) {
        /**
         * 继承UIComponent一定要声明“绘制到页面上的最终目标是什么”
         * this._self = this.something;
         */
        var _this = this;
        this.bindTarget = data.bindTarget;
        this.pageChangedAction = data.pageChangedAction;
        this.pageSelectAction = data.pageSelectAction;
        this.pageCtrl = $('<div class="page-ctrl"></div>');
        this.pager = $('<div class="pager"><span><b>100</b>Pages</span><a class="front"><i class="fa fa-step-backward front"/></a><a class="prev"><i class="fa fa-caret-left prev"/></a><div></div><a class="next"><i class="fa fa-caret-right next"/></a><a class="end"><i class="fa fa-step-forward end"/></a></div>');
        this.pageSizeSwitcher = $('<div class="page-size"><label>Show:</label><select></select></div>');
        this.reload(data);
        this.pageSizeSwitcher && this.pageSizeSwitcher.find('select').change(function (event) {
            _this.pageSize = parseInt($(this).val());
            _this.pageSelectAction.call(_this);
            window.event ? window.event.cancelBubble = true : event.stopPropagation();
        });
        this.name = name || this.__instance_id__;
        this.__self__ = this.pageCtrl;
    }
}, 'UIComponent');
/**
 * DateTimePicker类
 * 日期时间选择器
 */
Class('DateTimePicker', {
    container: null,
    panel: null,
    calender: null,
    data: null,
    time: null,
    type: 0,
    today: new Date(),
    supportedType: ['date', 'date time', 'period'],
    getTotalDaysOfMonth: function (month, year) {
        return (new Date(year, month + 1, 0)).getDate();
    },
    getDaysBeforeFirstDay: function (month, year) {
        var daysBefore = (new Date(year, month, 1)).getDay() - 1;
        return daysBefore == -1 ? 6 : daysBefore;
    },
    parse: function (string) {
        if (string) {
            var dt = string.split(' '), date = dt[0].split('-'), time;
            var arr = [parseInt(date[0]), parseInt(date[1]) - 1, parseInt(date[2]), 0, 0, 0];
            if (dt[1]) {
                time = dt[1].split(':');
                arr[3] = time[0] || 0;
                arr[4] = time[1] || 0;
                arr[5] = time[2] || 0;
            }
            return new Date(arr[0], arr[1], arr[2], arr[3], arr[4], arr[5]);
        }
        return new Date();
    },
    switchCalender: function ($cal, year, month) {
        var totalDays = this.getTotalDaysOfMonth(month, year), daysBefore = this.getDaysBeforeFirstDay(month, year), index = $cal.prev('.calender').length;
        $($cal.find('.year-month span b').get(0)).text(year);
        $($cal.find('.year-month span b').get(1)).text(month + 1);
        $cal.find('.dates').html('');
        for (var i = 1; i < 43; i++) {
            var $cell = $('<li class="date"></li>'), $anchor = $('<a href="#nogo">' + (i - daysBefore) + '</a>');
            if (i % 7 == 0 || (i + 1) % 7 == 0) $cell.addClass('weekend');
            if (i > daysBefore && i <= daysBefore + totalDays) {
                $cell.append($anchor);
                year == this.data[index].year && month == this.data[index].month && (i - daysBefore == this.data[index].date) && $cell.addClass('current');
            }
            $cal.find('.dates').append($cell);
        }
    },
    createCalender: function (year, month, date) {
        var _this = this, $cal = $('<div class="calender"><div class="year-month"><span><b>----</b>&nbsp;年&nbsp;<b>--</b>&nbsp;月</span><a href="#nogo" class="prev"></a><a href="#nogo" class="next"></a></div><ul class="days cf"><li>一</li><li>二</li><li>三</li><li>四</li><li>五</li><li class="weekend">六</li><li class="weekend">日</li></ul><ul class="dates cf"></ul></div>');
        this.calender.push($cal);
        this.data.push({
            year: year,
            month: month,
            date: date
        });
        this.switchCalender($cal, year, month);
        this.panel.append($cal.click(function (event) {
            var $target = $(event.target), $date = $target.parent('.date');
            var $ym = $(this).find('.year-month span b'), $year = $($ym.get(0)), $month = $($ym.get(1));
            var index = $(this).prev('.calender').length;
            var currentYear = parseInt($year.text());
            var currentMonth = parseInt($month.text()) - 1;
            var currentDate = parseInt($target.text());
            var $dtc = _this.panel.find('.date-time-ctrl');
            if ($date.length) {
                var $dateSelects = $dtc.find('select.date');
                _this.data[index].year = currentYear;
                _this.data[index].month = currentMonth;
                _this.data[index].date = currentDate;
                if (_this.type == 2) {
                    $($dateSelects.get(index)).prev().prev().val(currentYear);
                    $($dateSelects.get(index)).prev().val(currentMonth + 1);
                    $($dateSelects.get(index)).val(currentDate).trigger('change');
                } else {
                    $date.parent().find('.current').removeClass('current');
                    $target.parent().addClass('current');
                    _this.changeInput();
                }
                !_this.type && _this.finish();
            }
            if ($target.hasClass('prev')) {//上一个月点击
                var prevMonth = currentMonth ? currentMonth - 1 : 11, prevYear = currentMonth ? currentYear : currentYear - 1;
                if (prevMonth == 0 && prevYear == 2013) $target.hide();
                $target.next().show();
                _this.switchCalender($(this), prevYear, prevMonth);
            }
            if ($target.hasClass('next')) {//下一个月点击
                var nextMonth = currentMonth <= 11 ? currentMonth + 1 : 0, nextYear = currentMonth <= 11 ? currentYear : currentYear + 1;
                if (nextMonth == 11 && nextYear == _this.today.getFullYear() + 1) $target.hide();
                $target.prev().show();
                _this.switchCalender($(this), nextYear, nextMonth);
            }
        }));
    },
    createDateTimeCtrl: function (hours, minutes) {
        var _this = this, $dtc = $('<div class="date-time-ctrl"><button class="prim">确定</button></div>');
        if (this.type == 1) {
            $dtc.prepend('<select class="hour"></select><span>时</span><select class="minute"></select><span>分</span>');
            for (var i = 0; i < 24; i++) {
                $dtc.find('.hour').append('<option value="' + i + '">' + toDoubleDigits(i) + '</option>');
            }
            for (var i = 0; i < 60; i++) {
                $dtc.find('.minute').append('<option value="' + i + '">' + toDoubleDigits(i) + '</option>');
            }
            $dtc.find('.hour').val(this.data[0].hours = hours).change(function () {
                _this.hourSelectChanged($(this));
            });
            $dtc.find('.minute').val(this.data[0].minutes = minutes).change(function () {
                _this.minuteSelectChanged($(this));
            });
        } else {
            $dtc.prepend('<select class="year"></select><select class="month"></select><select class="date"></select><span>~</span><select class="year"></select><select class="month"></select><select class="date"></select>');
            for (var i = this.today.getFullYear() + 1; i > 2012; i--) {
                $dtc.find('.year').append('<option value="' + i + '">' + i + '</option>');
            }
            for (var i = 1; i < 13; i++) {
                $dtc.find('.month').append('<option value="' + i + '">' + toDoubleDigits(i) + '</option>');
            }
            $($dtc.find('.year').get(0)).val(this.data[0].year).change(function () {
                _this.yearSelectChanged(0, $(this));
            }).trigger('change');
            $($dtc.find('.year').get(1)).val(this.data[1].year).change(function () {
                _this.yearSelectChanged(1, $(this));
            }).trigger('change');
            $($dtc.find('.month').get(0)).val(this.data[0].month + 1).change(function () {
                _this.monthSelectChanged(0, $(this));
            }).trigger('change');
            $($dtc.find('.month').get(1)).val(this.data[1].month + 1).change(function () {
                _this.monthSelectChanged(1, $(this));
            }).trigger('change');
            $($dtc.find('.date').get(0)).val(this.data[0].date).change(function () {
                _this.dateSelectChanged(0, $(this));
            }).trigger('change');
            $($dtc.find('.date').get(1)).val(this.data[1].date).change(function () {
                _this.dateSelectChanged(1, $(this));
            }).trigger('change');
        }
        $dtc.find('button').click(function () {
            _this.finish();
        });
        this.panel.append($dtc)
    },
    yearSelectChanged: function (index, $this) {
        var year = parseInt($this.val());
        this.data[index].year = year;
        $this.next().trigger('change');
    },
    monthSelectChanged: function (index, $this) {
        var $date = $this.next(), year = this.data[index].year, month = parseInt($this.val()) - 1;
        var prevDate = parseInt($date.val()), maxDate = this.getTotalDaysOfMonth(month, year), date = prevDate < maxDate ? prevDate : maxDate;
        this.data[index].month = month;
        this.switchCalender(this.calender[index], year, month);
        $date.html('');
        for (var i = 1; i <= this.getTotalDaysOfMonth(month, year) ; i++) {
            $date.append('<option value="' + i + '">' + toDoubleDigits(i) + '</option>');
        }
        $date.val(date).trigger('change');
    },
    dateSelectChanged: function (index, $this) {
        var date = parseInt($this.val());
        this.data[index].date = date;
        this.calender[index].find('.dates .current').removeClass('current');
        $(this.calender[index].find('.dates .date a').get(date - 1)).parent().addClass('current');
        this.changeInput();
    },
    hourSelectChanged: function ($this) {
        var hours = parseInt($this.val());
        this.data[0].hours = hours;
        this.changeInput();
    },
    minuteSelectChanged: function ($this) {
        var minutes = parseInt($this.val());
        this.data[0].minutes = minutes;
        this.changeInput();
    },
    changeInput: function () {
        var $display = this.container.find('.display'), $input = $display.next(), data = this.data;
        this.time = [];
        if (this.type == 0) {
            $display.html(data[0].year + '-' + toDoubleDigits(data[0].month + 1) + '-' + toDoubleDigits(data[0].date));
            this.time.push((new Date(data[0].year, data[0].month, data[0].date)).getTime());
        }
        if (this.type == 1) {
            $display.html(data[0].year + '-' + toDoubleDigits(data[0].month + 1) + '-' + toDoubleDigits(data[0].date) + ' ' + toDoubleDigits(data[0].hours) + ':' + toDoubleDigits(data[0].minutes));
            this.time.push((new Date(data[0].year, data[0].month, data[0].date, data[0].hours, data[0].minutes)).getTime());
        }
        if (this.type == 2) {
            $display.html(data[0].year + '-' + toDoubleDigits(data[0].month + 1) + '-' + toDoubleDigits(data[0].date)).append('<b>至</b>');
            $display.append(data[1].year + '-' + toDoubleDigits(data[1].month + 1) + '-' + toDoubleDigits(data[1].date));
            this.time.push((new Date(data[0].year, data[0].month, data[0].date)).getTime());
            this.time.push((new Date(data[1].year, data[1].month, data[1].date)).getTime());
            $input.next().val(this.time[1]);
        }
        $input.val(this.time[0]);
    },
    begin: function () {
        this.panel.show();
    },
    finish: function (irr_clk) {
        if (!irr_clk) {
            this.container.attr('not-irrelevant-click', 'true');
            this.container.trigger('dtp-changed');
        }
        this.panel.hide();
    },
    init: function (time, end_time) {
        var time = time, month = time.getMonth(), year = time.getFullYear(), date = time.getDate(), hours = time.getHours(), minutes = time.getMinutes();
        this.panel.html('').css('width', '300px');
        this.createCalender(year, month, date);
        if (this.type == 2) {
            var end_time = end_time, nextMonth = end_time.getMonth(), nextYear = end_time.getFullYear(), nextDate = end_time.getDate();
            this.panel.css('width', '600px');
            this.createCalender(nextYear, nextMonth, nextDate);
        }
        if (this.type) {
            this.createDateTimeCtrl(hours, minutes);
        }
        this.changeInput();
    },
    DateTimePicker: function (name, $container, type, time, end_time) {
        var _this = this, _type = $.inArray(type || '', this.supportedType), time = this.parse(time), end_time = this.parse(end_time);
        this.name = name || this.__instance_id__;
        this.container = $container;
        this.panel = $('<div class="date-time-picker-panel"></div>');
        this.calender = [];
        this.data = [];
        this.type = _type == -1 ? 0 : _type;
        this.panel.css((this.container.offset().left + this.container.outerWidth()) < ($document.width() / 2) ? 'left' : 'right', '0px');
        this.container.append(this.panel).bind('relevant-click', function () {
            if ($(this).attr('not-irrelevant-click') == 'true') {
                $(this).removeAttr('not-irrelevant-click');
            } else {
                _this.begin();
            }
        }).bind('irrelevant-click', function () {
            _this.finish(true);
        });
        regRelevantClick(this.container);
        this.init(time, end_time);
        this.__self__ = this.panel;
    }
}, 'UIComponent');
/***********************************************************************************************************************
 *
 * 通用页面元件代码区域
 * TODO:
 * 在这里进行通用页面元件定义
 *
 **********************************************************************************************************************/
Action({
    'page-num': function () {
        var pageCtrl = $$$($(this).closest('.page-ctrl').attr('instance-id'));
        pageCtrl.page = parseInt($(this).attr('page-num'));
        pageCtrl.pageChangedAction.call(pageCtrl);
    },
    'sort': function () {
        var td = $(this);
        td = td.is('a') ? td.parent() : td;
        var that = td.find('.fa'), tr = td.parent(), colName = td.attr('col-name'), order = 'desc', curClass = '',
		list = td.closest('.THEAD').parent(), pageCtrlEle = list.next('.page-ctrl'), pageCtrl = $$$(pageCtrlEle.attr('instance-id'));
        if (that.hasClass('fa-sort-desc')) {
            curClass = 'fa fa-sort-asc';
            order = 'asc';
        } else {
            curClass = 'fa fa-sort-desc';
        }
        tr.find('.fa').attr('class', 'fa');
        that.attr('class', curClass);
        pageCtrl.sortType = order;
        pageCtrl.sortName = colName;
        pageCtrl.pageChangedAction.call(pageCtrl);
    }
});
/***********************************************************************************************************************
 *
 * 全局事件支持
 * TODO:
 * 在这里添加页面功能代码
 *
 **********************************************************************************************************************/
(function ($GLOBAL) {
    /**
     * 页面大小变化时的处理
     */
    /**$window.resize(function () {
		$('aside').css('height', $window.height() - 100 + 'px');
		$('main').css('height', $window.height() - 100 + 'px');
		$('.main-inside').css('min-width', $('main').width() - 80 + 'px');
	});
     /**
     * 支持LinkageGroup相关html标签的属性和功能
     */
    $document.change(function (event) {
        var $target = $(event.target), gid = $target.attr('link-handler') || null, val = $target.val();
        if (gid) {
            $('[link-group=' + gid + ']').each(function () {
                var $this = $(this), item = $this.attr('link-item');
                if (item) {
                    if (item == val) {
                        $this.hasClass('hide') && $this.removeClass('hide');
                    } else {
                        !$this.hasClass('hide') && $this.addClass('hide');
                    }
                }
            });
        }
    });
    /**
     * 支持Ajax文件上传功能
     */
    this.prepareFileUploader = function ($component, url) {
        var $fileName = $component.find('.file-name');
        $component.find('.file-url').val(url);
        $fileName.attr('text', $fileName.text()).removeClass('hint').removeClass('error').attr('title', url).text(url);
        if ($component.attr('image-preview')) {
            var $oldImage = $component.find('.img-preview'), $img = $('<div class="img-preview"><img src="' + url + '" alt="' + url + '" /></div>');
            $oldImage.length ? $oldImage.replaceWith($img) : $component.append($img);
        }
    };
    $document.click(function (event) {
        var $target = $(event.target);
        if ($target.hasClass('file-uploader-button')) {
            var $component = $target.closest('.file-uploader'), name = $component.attr('name');
            var url = $component.attr('url') ? $component.attr('url') : ($component.attr('file-type') ? ($component.attr('file-type') == 'image' ? Config('file_upload_service_url_image') : Config('file_upload_service_url')) : Config('file_upload_service_url'));
            var $form = $('<form method="post" enctype="multipart/form-data" action="' + url + '" name="FormFileUploader_' + name + '" target="IframeFileUploader_' + name + '"></form>');
            var $name = $('<input name="uploaderName" type="text" />').val(name);
            var $file = $('<input name="fileName" type="file" />');
            var $iframe = $('<iframe name="IframeFileUploader_' + name + '"></iframe>');
            var $tool = $('<div class="file-uploader-tool hide"></div>').append($form.append($name).append($file)).append($iframe);
            var $old = $component.find('.file-uploader-tool');
            Cache('FILE_UPLOADER')[name] = {
                component: $component,
                success: function (name, url) {
                    var $component = Cache('FILE_UPLOADER')[name].component, $button = $component.find('.file-uploader-button');
                    prepareFileUploader($component, url);
                    $component.find('.file-uploader-tool').remove();
                    $button.removeClass('uploading').text($button.attr('text')).removeAttr('text').removeAttr('disabled');
                    Action($component.attr('success')).call($component, url);
                },
                failed: function (name, code, message) {
                    var $component = Cache('FILE_UPLOADER')[name].component, $fileName = $component.find('.file-name'), $button = $component.find('.file-uploader-button');
                    $fileName.attr('text', $fileName.text()).attr('title', message).text(message).addClass('error').addClass('hint');
                    $component.find('.file-url').val('');
                    $component.find('.file-uploader-tool').remove();
                    $button.removeClass('uploading').text($button.attr('text')).removeAttr('text').removeAttr('disabled');
                    Action($component.attr('failed')).call($component, code, message);
                }
            };
            $old.length ? $old.replaceWith($tool) : $component.append($tool);
            $file.change(function () {
                $(this).closest('form').submit();
                $target.addClass('uploading').attr('disabled', 'disabled').attr('text', $target.text()).text('');
            }).trigger('click');
        }
    });
    /**
     * 支持a、button元素的点击事件
     */
    $document.click(function (event) {
        var $target = $(event.target), act = null;
        if ($target.attr('href')) act = $target.attr('href').slice(1);
        if ($target.attr('action')) act = $target.attr('action');
        act && Cache('ACTION')[act] && Cache('ACTION')[act].call(event.target);
    });
    /**
     * 支持页面加载后根据地址#号后面内容执行对应操作
     */
    $document.ready(function () {
        var act = location.hash.slice(1);
        Cache('ACTION').__hash_actions__[act] && Cache('ACTION').__hash_actions__[act].call($document);
    });
    /**
     * 支持页面GET方式传递的参数
     */
    $document.ready(function () {
        if (location.search.length) {
            var args = location.search.slice(1).split('&');
            for (var i = 0; i < args.length; i++) {
                var arg = args[i].split('=');
                Cache('URL_ARGUMENTS')[arg[0]] = arg[1];
            }
        }
    });
    /**
     * 支持页面无关点击事件的功能
     */
    $document.click(function (event) {
        var $intercepter = $(event.target).closest('[relevant-click-intercepter]');
        for (var i = 0; i < Cache('RELEVANT_CLICK_COMPONENT').length; i++) {
            Cache('RELEVANT_CLICK_COMPONENT')[i].attr('relevant-click-intercepter') != $intercepter.attr('relevant-click-intercepter') && Cache('RELEVANT_CLICK_COMPONENT')[i].trigger('irrelevant-click');
        }
        $intercepter.length && $intercepter.trigger('relevant-click');
    });
})(this);
/***********************************************************************************************************************
 *
 * 通用页面代码区域
 * TODO:
 * 在这里写通用页面代码
 *
 **********************************************************************************************************************/
$(function () {
});
function getScrollbarWidth() {
    var oP = document.createElement('p'),
        styles = {
            width: '100px',
            height: '100px',
            overflowY: 'scroll'
        }, i, scrollbarWidth;
    for (i in styles) oP.style[i] = styles[i];
    document.body.appendChild(oP);
    scrollbarWidth = oP.offsetWidth - oP.clientWidth;
    oP.remove();
    return scrollbarWidth;
}
//$("body").css("width", $(window).width());