$(document).on('click', "#btAddFilter", function() {

    $('#addFilterDiv').find('input').removeClass('error').siblings('span.hint').css('display', 'none');
    $("#filterType").val("Any");
    $("#filterType").change();

    $.each($('#addFilterDiv input'), function() {
        $(this).blur(function() {
            required(this);
        }).focus(function() {
            isFocus(this);
        });
    });

    $("#filterType").change(function() {
        //if($("#filterType").val() == "Any")
        {
            $("#IPV4Page").hide();
            $("#IPRangePage").hide();
            $("#IPv6Page").hide();
            $("#MacPage").hide();
        }
        if ($("#filterType").val() == "IPv4") {
            $("#IPV4Page").show();
        } else if ($("#filterType").val() == "IPRange") {
            $("#IPRangePage").show();
        } else if ($("#filterType").val() == "IPv6") {
            $("#IPv6Page").show();
        } else if ($("#filterType").val() == "Mac") {
            $("#MacPage").show();
        }
    });

    $("#addIPFilter").on("click", function() {
        var filterType = $("#filterType").val();
        var ipFamily;
        var address;
        var address2;
        var access = parseInt($("#Access").val());

        if (filterType == "Any") {
            ipFamily = AF_INET;
            address = "0.0.0.0";
        } else if (filterType == "IPv4") {
            ipFamily = AF_INET;
            address = $("#txtIPv4").val();
            if (address == "") {
                $("#txtIPv4").addClass('error').siblings('span.hint:eq(0)').css('display', 'block');
                return false;
            }
        } else if (filterType == "IPRange") {
            ipFamily = AF_RANGE;
            address = $("#txtStartIP").val();
            address2 = $("#txtEndIP").val();
            if (address == "") {
                $("#txtStartIP").addClass('error').siblings('span.hint:eq(0)').css('display', 'block');
                return false;
            }
            if (address2 == "") {
                $("#txtEndIP").addClass('error').siblings('span.hint:eq(0)').css('display', 'block');
                return false;
            }
        } else if (filterType == "IPv6") {
            ipFamily = AF_INET6;
            address = $("#txtIPv6").val();
            if (address == "") {
                $("#txtIPv6").addClass('error').siblings('span.hint:eq(0)').css('display', 'block');
                return false;
            }
        } else if (filterType == "Mac") {
            ipFamily = AF_MAC;
            address = $("#txtMac").val();
            if (address == "") {
                $("#txtMac").addClass('error').siblings('span.hint:eq(0)').css('display', 'block');
                return false;
            }
        }

        $.ajax({
            url: '/api/storageservers/' + CurServer + '/targets/' + CurTargetId + '/ipfilters',
            type: 'POST',
            data: JSON.stringify({
                IPFamily: ipFamily,
                Address: address,
                Address2: address2,
                Access: access
            }),
            contentType: "application/json",
            dataType: 'JSON',
            success: function(data) {
                if (data.ReturnCode == 0) {
                    bootbox.alert({
                        buttons: {
                            ok: {
                                label: 'OK',
                                className: 'btn-success'
                            }
                        },
                        message: "Add successfully.",
                        callback: function() {
                            showFilters(CurTargetId); //ˢ���б�
                            $("#adddismiss").trigger("click");
                        }
                    });
                } else {
                    bootbox.alert({
                        buttons: {
                            ok: {
                                label: 'OK',
                                className: 'btn-success'
                            }
                        },
                        message: "Failed with status: " + data.ReturnCode,
                        callback: function() {

                        }
                    });
                }
            }
        });
    });

});


$(document).on('click', "#btAddChap", function() {

    var totalData = new Array;

    $.ajax({
        url: '/api/storageservers/' + CurServer + '/users/',
        type: 'GET',
        dataType: 'JSON',
        async: false,
        success: function(response) {

            for (i = 0; i < response.Users.length; i++) {
                var dat = {
                    id: response.Users[i].ID,
                    Name: response.Users[i].Name,
                    Type: TARGET_RELATION_TYPE_USER,
                    TypeName: response.Users[i].Name == "Guest" ? "Special" : "User"
                }

                totalData.push(dat);
            }
        }
    }); //ajax.


    $.ajax({
        url: '/api/storageservers/' + CurServer + '/groups/',
        type: 'GET',
        dataType: 'JSON',
        async: false,
        success: function(response) {

            for (i = 0; i < response.Groups.length; i++) {
                var dat = {
                    id: response.Groups[i].ID,
                    Name: response.Groups[i].Name,
                    Type: TARGET_RELATION_TYPE_GROUP,
                    TypeName: "Group"
                }

                totalData.push(dat);
            }
        }
    }); //ajax.


    $('#addChapTable').bootstrapTable({
        showHeader: true,
        classes: 'table-striped table-condensed table-hover btable',
        columns: [{
                field: '',
                title: '',
                width: 15,
                formatter: function(value, row, index) {
                    return '<input type="checkbox" name="chkAddChap" data-id="' + totalData[index].id + '" value="' + totalData[index].Type + '"/>'; //).attr('class', 'border-right').attr('data-id', data.id);

                },
                //events: 'actionEvents'
            },
            {
                field: 'Name',
                title: 'CHAP Name',
                width: 50
            },
            {
                field: 'TypeName',
                title: 'Type',
                width: 25
            }
        ],

        data: totalData
    });
    $('#addChapTable').bootstrapTable('load', totalData);

    $("#btAddChapOK").on("click", function(e) {

        $("input[name=chkAddChap]:checked").each(function() {
            ChapId = $(this).attr("data-id");
            Type = $(this).val();

            $.ajax({
                url: '/api/storageservers/' + CurServer + '/targets/' + CurTargetId + '/chaps',
                type: 'POST',
                data: JSON.stringify({
                    ID: parseInt(ChapId),
                    Type: parseInt(Type),
                    Access: 0
                }),
                contentType: "application/json",
                dataType: 'JSON',
                success: function(data) {
                    if (data.ReturnCode == 0) {
                        bootbox.alert({
                            buttons: {
                                ok: {
                                    label: 'OK',
                                    className: 'btn-success'
                                }
                            },
                            message: "Add successfully.",
                            callback: function() {
                                showChaps(CurTargetId); //ˢ���б�
                                $("#adddismiss").trigger("click");
                            }
                        });
                    } else {
                        bootbox.alert({
                            buttons: {
                                ok: {
                                    label: 'OK',
                                    className: 'btn-success'
                                }
                            },
                            message: "Failed with status: " + data.ReturnCode,
                            callback: function() {

                            }
                        });
                    }
                }
            }); //ajax.
        });
    });


});

function showGeneral(ServerId) {
    var ServerName = "";
    $.ajax({
        url: '/api/storageservers/' + ServerId,
        type: 'GET',
        dataType: 'JSON',
        async: false,
        success: function(response) {

            CurStoragePoolName = ServerName = response.ServerName;

            if (response.HostName != "")
                $("#lbServerName").html(response.HostName);
            else
                $("#lbServerName").html(response.ServerName);

            if (response.ServerIP != "")
                $("#lbServerIP").html(response.ServerIP);
            else
                $("#lbServerIP").html(response.ServerName);

            $("#lbServerPort").html(response.Port);
            $("#lbUserName").html(response.UserName);

            if (response.Status) {
                $("#lbStatus").html("Online");
                $("#lbTotalMemory").html(FormatSize(response.TotalMemory));
                $("#lbFreeMemory").html(FormatSize(response.FreeMemory));
                $("#lbHugePages").html(response.HugePages);
                $("#lbLicense").html(response.LicName);
            } else {
                $("#lbStatus").html("Offline");
                $("#lbTotalMemory").html("-");
                $("#lbFreeMemory").html("-");
                $("#lbHugePages").html("-");
                $("#lbLicense").html("-");
            }

            //$("#lbCapacity").html(FormatSize(response.Capacity));

            /*if (response.Enabled == 1)
                $("#lbStatus").html("Enabled");
            else
                $("#lbStatus").html("Disabled");

            $("#lbUseRate").html(response.DataUseRate + "%");*/

            return "";
        }
    }); //ajax

    return ServerName;
}

function showCPUs(ServerId) {
    $.ajax({
        url: '/api/storageservers/' + ServerId + '/cpus',
        type: 'GET',
        dataType: 'JSON',
        async: false,
        success: function(response) {

            var Data = response.CPUs == null ? [] : response.CPUs;
            window.actionEvents = {

                'click .start': function(e, value, row, index) {

                    beginWait("Showing Volumes");

                    $.ajax({
                        url: '/api/clusterservers/' + ServerId + '/storagepools/' + row.ID + '/start',
                        type: 'PUT',
                        dataType: 'JSON',
                        async: false,
                        success: function(Ret) {

                            if (Ret.ReturnCode == 0)
                                showVolumes(TargetId);
                            else {
                                bootbox.alert({
                                    buttons: {
                                        ok: {
                                            label: 'OK',
                                            className: 'btn-success'
                                        }
                                    },
                                    message: "Failed with status: " + Ret.ReturnCode,
                                    callback: function() {}
                                });
                            }

                            endWait();
                        },
                        error: function() {
                            endWait();
                        }
                    }); //ajax

                    endWait();

                    //var source = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index]);
                    //var target = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index - 1]);
                    //$('#portal6Table').bootstrapTable('updateRow', { 'index': index - 1, 'row': JSON.parse(source) });
                    //$('#portal6Table').bootstrapTable('updateRow', { 'index': index, 'row': JSON.parse(target) });
                },
                'click .stop': function(e, value, row, index) {

                    $("#doConfrimText").html("Do you really want to stop the service?");
                    $('#doConfrim').modal('show');
                    $("#doConfrimOK").unbind("click").on("click", function() {
                        beginWait("");

                        $.ajax({
                            url: '/api/storageservers/' + CurServer + '/storagepools/' + TargetId + '/volumes/',
                            type: 'PUT',
                            dataType: 'JSON',
                            async: false,
                            success: function(Ret) {

                                //window.alert(Ret.ReturnCode);
                                showVolumes(TargetId);

                                endWait();

                                $('#doConfrim').modal('hide');
                            }
                        }); //ajax

                        endWait();
                    });

                },
                'click .remove': function(e, value, row, index) {

                    var source = $('#cpusTable').bootstrapTable('getData')[index];
                    $("#doConfrimText").html("Do you really want to remove the volume?");
                    $('#doConfrim').modal('show');
                    $("#doConfrimOK").unbind("click").on("click", function() {
                        beginWait("");

                        $.ajax({
                            url: '/api/storageservers/' + CurServer + '/storagepools/' + TargetId + '/volumes/' + source.id,
                            type: 'DELETE',
                            dataType: 'JSON',
                            async: false,
                            success: function(Ret) {

                                showVolumes(TargetId);

                                endWait();

                                $('#doConfrim').modal('hide');
                            }
                        }); //ajax

                        endWait();
                    });

                }
            }

            $('#cpusTable').bootstrapTable({
                //classes: 'table-striped table-condensed table-hover btable subtable',
                classes: 'table table-hover subtable',
                columns: [{
                        field: 'Id',
                        title: 'ID',
                        width: 10
                    },
                    {
                        field: 'Name',
                        title: 'Name',
                        width: 30
                    },
                    {
                        field: 'Core',
                        title: 'Core ID',
                        width: 20
                    },
                    {
                        field: 'Socket',
                        title: 'Socket ID',
                        width: 25
                    },
                    {
                        field: 'Flags',
                        title: 'Using',
                        width: 40,
                        formatter: function(value, row, index) {
                            if ((value & NVMS_CORE_FLAG_INUSE) == 0)
                                return "No";
                            else if (value & NVMS_CORE_FLAG_POLLING)
                                return "Polling Worker";
                            else if (value & NVMS_CORE_FLAG_AIO)
                                return "Runtime Service";
                            else
                                return "Unknown Using";
                        }
                    }
                    /*,
                                        {
                                            field: 'OP',
                                            title: '<i class="glyphicon glyphicon-plus-sign"></i><a href="#" data-toggle="modal" data-target=".addStorageVolume" style="color: #234c72;" class="createvolume"><span id="btCreateVolume">Add</span></a>',
                                            width: 15,
                                            formatter: function(value, row, index) {
                                                return '<nobr><a class="fa fa-remove action remove" href="javascript:void(0)" title="Delete" style="color: #234c72;"></a></nobr>' +
                                                    '&nbsp;<nobr><a class="fa fa-arrows-h action expand" href="javascript:void(0)" title="Expand" style="color: #234c72;"></a></nobr>';
                                            },
                                            events: 'actionEvents'
                                        }*/
                ],
                data: Data
            });
            $('#cpusTable').bootstrapTable('load', Data);

        }
    }); //ajax
}

function showNics(ServerId) {
    $.ajax({
        url: '/api/storageservers/' + ServerId + '/nics',
        type: 'GET',
        dataType: 'JSON',
        success: function(response) {
            var Data = response.NICs == null ? [] : response.NICs;

            /*for (var i = 0; i < Data.length; i++) {
                if (Data[i].DeviceName.indexOf("/dev/dm-") == 0) {
                    Data.splice(i, 1);
                    i = 0;
                }
            }*/

            window.diskActionEvents = {
                'click .up': function(e, value, row, index) {
                    var source = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index]);
                    var target = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index - 1]);
                    $('#portal6Table').bootstrapTable('updateRow', { 'index': index - 1, 'row': JSON.parse(source) });
                    $('#portal6Table').bootstrapTable('updateRow', { 'index': index, 'row': JSON.parse(target) });
                },
                'click .down': function(e, value, row, index) {
                    var source = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index]);
                    var target = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index + 1]);
                    $('#portal6Table').bootstrapTable('updateRow', { 'index': index + 1, 'row': JSON.parse(source) });
                    $('#portal6Table').bootstrapTable('updateRow', { 'index': index, 'row': JSON.parse(target) });
                },
                'click .init': function(e, value, row, index) {
                    $('#initDiskPath').val(row.DeviceName);
                    $('#initDisk').modal('show');
                }
            }

            $('#nicsTable').bootstrapTable({
                classes: 'table-striped table-condensed table-hover btable subtable',
                columns: [{
                        field: 'Id',
                        title: 'ID',
                        width: 10
                    },
                    {
                        field: 'Name',
                        title: 'NIC Name',
                        width: 20
                    },
                    {
                        field: 'Address',
                        title: 'IP Address',
                        width: 20
                    },
                    {
                        field: 'Family',
                        title: 'Type',
                        width: 10,
                        formatter: function(value, row, index) {
                            if (value == 2)
                                return "IPv4";
                            else
                                return "IPv6";
                        }
                    },
                    {
                        field: 'HWAddress',
                        title: 'Hardware Address',
                        width: 20
                    },
                    {
                        field: 'Metric',
                        title: 'Metric',
                        width: 10
                    },
                    {
                        field: 'Mtu',
                        title: 'MTU',
                        width: 10
                    }
                    /*
                                        {
                                            field: 'OP',
                                            title: 'OP',
                                            width: 15,
                                            formatter: function(value, row, index) {
                                                return '<nobr><a class="fa fa-cog action init" href="javascript:void(0)" title="Initialize" style="color: #234c72;"></a></nobr>';
                                            },
                                            events: 'diskActionEvents'
                                        } */
                ],
                data: Data
            });
            $('#nicsTable').bootstrapTable('load', Data);


        }
    }); //ajax
}

function showDisks(ServerId) {
    $.ajax({
        url: '/api/storageservers/' + ServerId + '/disks',
        type: 'GET',
        dataType: 'JSON',
        success: function(response) {
            var Data = response.Disks == null ? [] : response.Disks;

            window.diskActionEvents = {
                'click .up': function(e, value, row, index) {
                    var source = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index]);
                    var target = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index - 1]);
                    $('#portal6Table').bootstrapTable('updateRow', { 'index': index - 1, 'row': JSON.parse(source) });
                    $('#portal6Table').bootstrapTable('updateRow', { 'index': index, 'row': JSON.parse(target) });
                },
                'click .down': function(e, value, row, index) {
                    var source = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index]);
                    var target = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index + 1]);
                    $('#portal6Table').bootstrapTable('updateRow', { 'index': index + 1, 'row': JSON.parse(source) });
                    $('#portal6Table').bootstrapTable('updateRow', { 'index': index, 'row': JSON.parse(target) });
                },
                'click .init': function(e, value, row, index) {
                    $('#initDiskPath').val(row.DeviceName);
                    $('#initDisk').modal('show');
                }
            }

            $('#disksTable').bootstrapTable({
                classes: 'table-striped table-condensed table-hover btable subtable',
                columns: [{
                        field: 'ID',
                        title: 'ID',
                        width: 10
                    },
                    {
                        field: 'DeviceName',
                        title: 'Device Path',
                        width: 20
                    },
                    {
                        field: 'MountPoints',
                        title: 'Mount Points',
                        width: 30
                    },
                    {
                        field: 'Used',
                        title: 'Used',
                        width: 10,
                        formatter: function(value, row, index) {
                            if (value)
                                return "Yes";
                            else
                                return "No";
                        }
                    },
                    {
                        field: 'Description',
                        title: 'Description',
                        width: 40
                    },
                    {
                        field: 'Size',
                        title: 'Size',
                        width: 20,
                        formatter: function(value, row, index) {
                            return FormatSize(value);
                        }
                    }
                    /*
                                        {
                                            field: 'OP',
                                            title: 'OP',
                                            width: 15,
                                            formatter: function(value, row, index) {
                                                return '<nobr><a class="fa fa-cog action init" href="javascript:void(0)" title="Initialize" style="color: #234c72;"></a></nobr>';
                                            },
                                            events: 'diskActionEvents'
                                        } */
                ],
                data: Data
            });
            $('#disksTable').bootstrapTable('load', Data);
        }
    }); //ajax
}

function showNvmes(ServerId) {
    $.ajax({
        url: '/api/storageservers/' + ServerId + '/nvmes',
        type: 'GET',
        dataType: 'JSON',
        success: function(response) {
            var Data = response.NVMEs == null ? [] : response.NVMEs;

            window.diskActionEvents = {
                'click .up': function(e, value, row, index) {
                    var source = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index]);
                    var target = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index - 1]);
                    $('#portal6Table').bootstrapTable('updateRow', { 'index': index - 1, 'row': JSON.parse(source) });
                    $('#portal6Table').bootstrapTable('updateRow', { 'index': index, 'row': JSON.parse(target) });
                },
                'click .down': function(e, value, row, index) {
                    var source = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index]);
                    var target = JSON.stringify($('#portal6Table').bootstrapTable('getData')[index + 1]);
                    $('#portal6Table').bootstrapTable('updateRow', { 'index': index + 1, 'row': JSON.parse(source) });
                    $('#portal6Table').bootstrapTable('updateRow', { 'index': index, 'row': JSON.parse(target) });
                },
                'click .init': function(e, value, row, index) {
                    $('#initDiskPath').val(row.DeviceName);
                    $('#initDisk').modal('show');
                }
            }

            $('#nvmesTable').bootstrapTable({
                classes: 'table-striped table-condensed table-hover btable subtable',
                columns: [{
                        field: 'Id',
                        title: 'ID',
                        width: 10
                    },
                    {
                        field: 'Modal',
                        title: 'Modal',
                        width: 30
                    },
                    {
                        field: 'DevPath',
                        title: 'Device Path',
                        width: 20
                    },
                    {
                        field: 'IoQpairs',
                        title: 'IO QParis',
                        width: 8
                    },
                    {
                        field: 'Namespaces',
                        title: 'Namespaces',
                        width: 10
                    },
                    {
                        field: 'InUse',
                        title: 'In Use',
                        width: 8,
                        formatter: function(value, row, index) {
                            if (value)
                                return "Yes";
                            else
                                return "No";
                        }
                    },
                    {
                        field: 'Size',
                        title: 'Size',
                        width: 20,
                        formatter: function(value, row, index) {
                            return FormatSize(row.BlockCount * row.BlockSize);
                        }
                    },
                    {
                        field: 'OP',
                        title: 'Switch Driver',
                        width: 10,
                        formatter: function(value, row, index) {
                            return '<nobr><a class="fa fa-cog action init" href="javascript:void(0)" title="Initialize" style="color: #234c72;"></a></nobr>';
                        },
                        events: 'diskActionEvents'
                    }
                ],
                data: Data
            });
            $('#nvmesTable').bootstrapTable('load', Data);
        }
    }); //ajax
}

function showLogs(NodeId) {
    $.ajax({
        url: '/api/clusterservers/' + NodeId + '/logs',
        type: 'GET',
        dataType: 'JSON',
        async: false,
        success: function(response) {

            var Data = response.Logs == null ? [] : response.Logs;

            $('#logsTable').bootstrapTable({
                classes: 'table-striped table-condensed table-hover btable',
                clickToSelect: true,
                columns: [{
                        field: 'LogLevel',
                        title: 'Log Level',
                        width: '10%',
                        formatter: function(value, row, index) {
                            if (value == LOG_LEVEL_INFORMATION)
                                return '<i class="icon-info-sign icon-white" style="color:#a0a0b0;"></i>';
                            else if (value == LOG_LEVEL_WARNNING)
                                return '<i class="icon-warning-sign icon-white" style="color:#a0a0b0;"></i>';
                            else
                                return '<i class="icon-remove icon-white" style="color:#a0a0b0;"></i>';
                        }
                    },
                    {
                        field: 'Date',
                        title: 'Date',
                        width: '15%',
                        formatter: function(value, row, index) {
                            return row.Date + " " + row.Time;
                        }
                    },
                    {
                        field: 'Message',
                        title: '<div style="display:block;float:left;">Message</div>' +
                            '<div style="display:block;float:right;padding-right:30px;"><a class="fa fa-trash-o" href="javascript:void(0)" style="color:#234c72"><span id="btClearLog">Clear</span></a></div>' +
                            '<div style="display:block;float:right;padding-right:8px;"><a class="fa fa-save" href="/api/clusterservers/' + NodeId + '/logs/export" style="color:#234c72"><span id="btExportLog">Export</span></a></div>',
                        width: '60%'
                    },
                    {
                        field: 'Message',
                        title: '',
                        width: '1%',
                        formatter: function(value, row, index) {
                            return ""
                        }
                    }
                ],
                data: Data
            });
            $('#logsTable').bootstrapTable('load', Data);

            //$('#logsTable').find('.TBODY').css('height', '10px');
            //$(window).resize(function() {
            //    $('#logsTable').find('.TBODY').css('height', '10px');
            //});

        }
    }); //ajax
}

function selServer(serverid) {
    //beginWait("");

    var poolName = showGeneral(serverid);
    if (poolName == "")
        $("#poolTitle").html("Unknown");
    else
        $("#poolTitle").html(poolName);

    showDisks(serverid);
    showCPUs(serverid);
    showNics(serverid);
    showNvmes(serverid);
    //showLogs(targetid);

    //endWait();
    //showAppbyTarget(targetName, "Applications");
    CurServerId = serverid;
}


$('#createVolumeForm input').each(function() {
    $(this).focus(function() {
        isFocus(this);
    });
});

$("#btCreateVolumeOK").on("click", function() {

    $('#createVolumeForm input').each(function() {
        required(this);
    });
    if ($('#createVolumeForm input.error').length != 0 || $('#createVolumeForm select.error').length != 0)
        return false;

    $('#waitModal').modal({ backdrop: 'static', keyboard: false });

    $.ajax({
        url: '/api/storageservers/' + CurServer + '/storagepools/' + CurServerId + '/volumes',
        type: 'POST',
        contentType: "application/json",
        data: JSON.stringify({
            Name: $('#createVolumeName').val(),
            Capacity: parseInt($('#createVolumeSize').val()) * 1024 * 1024 * 1024,
            Flags: 0,
            Quota: 0,
            Format: 0
        }),
        dataType: 'JSON',
        success: function(data) {
            if (data.ReturnCode == 0) {
                showVolumes(0);
                $("#createvolumedismiss").click();
                $('#createVolumeName').val("");
            } else {
                bootbox.alert({
                    buttons: {
                        ok: {
                            label: 'Failed',
                            className: 'btn-success'
                        }
                    },
                    message: "Failed with status " + data.ReturnCode,
                    callback: function() {
                        $('#createVolumeName').val("");
                    }
                });
            }

            $('#waitModal').modal('hide');
        }
    }); //ajax

});

$("#delVolumeOK").on("click", function() {
    $('#waitModal').modal({ backdrop: 'static', keyboard: false });
    $.ajax({
        url: '/api/flex/volumes/' + $("#deleteVolumeId").val(),
        type: 'DELETE',
        contentType: "application/json",
        dataType: 'JSON',
        success: function(data) {
            if (data.ReturnCode == 0) {
                showVolumes(0);
                $("#delvolumedismiss").click();
            } else {
                bootbox.alert({
                    buttons: {
                        ok: {
                            label: 'Failed',
                            className: 'btn-success'
                        }
                    },
                    message: "Failed with status: " + data.ReturnCode,
                    callback: function() {}
                });
            }

            $('#waitModal').modal('hide');
        }
    }); //ajax

});

$('a[data-toggle="tab"]').on('shown.bs.tab', function(e) {
    var target = $(e.target).attr("href") // activated tab
    if (target == "#General") {
        showGeneral(CurServerId);
    } else if (target == "#Disks") {
        showDisks(CurServerId);
    } else if (target == "#CPUs") {
        showCPUs(CurServerId);
    } else if (target == "#NICs") {
        showNics(CurServerId);
    } else if (target == "#Disks") {
        showDisks(CurServerId);
    } else if (target == "#Nvmes") {
        showNvmes(CurServerId);
    } else if (target == "#Logs") {
        showLogs(CurServerId);
    }
    //alert(target); 
});

$(document).on('click', "#btAddDisk", function() {
    //$("#btAddDisk").on("click", function() {
    $.ajax({
        url: '/api/clusterservers/' + CurServerId + '/volumes',
        type: 'GET',
        contentType: "application/json",
        async: false,
        dataType: 'JSON',
        success: function(data) {

            $('#addDiskDevice').empty();

            var Disks = data.Volumes;
            var option = '';
            for (var i = 0; i < Disks.length; i++) {
                if (0 == Disks[i].DeviceName.indexOf("/dev/ram"))
                    continue;
                option += '<option data-id="1" value="' + Disks[i].DeviceName + '">' + Disks[i].DeviceName + '</option>';
            }

            $('#addDiskDevice').append(option);
        }
    }); //ajax

});

$('#initDiskForm input').each(function() {
    $(this).focus(function() {
        isFocus(this);
    });
});

$("#btInitDiskOK").on("click", function() {

    $('#initDiskForm input').each(function() {
        required(this);
    });

    if ($('#initDiskForm input.error').length != 0 || $('#initDiskForm select.error').length != 0)
        return false;

    beginWait("");

    $.ajax({
        url: '/api/clusterservers/' + CurServerId + '/backends',
        type: 'POST',
        contentType: "application/json",
        data: JSON.stringify({
            DiskPath: $('#initDiskPath').val(),
            MountPath: $('#addDiskMountPath').val()
        }),
        dataType: 'JSON',
        success: function(data) {
            if (data.ReturnCode == 0) {
                bootbox.alert({
                    buttons: {
                        ok: {
                            label: 'OK',
                            className: 'btn-success'
                        }
                    },
                    message: "Success.",
                    callback: function() {
                        $("#initdiskdismiss").trigger("click");
                    }
                });
            } else {
                bootbox.alert({
                    buttons: {
                        ok: {
                            label: 'Failed',
                            className: 'btn-success'
                        }
                    },
                    message: "",
                    callback: function() {}
                });
            }

            endWait();
        }
    }); //ajax

});

$('#addDiskForm input').each(function() {
    $(this).focus(function() {
        isFocus(this);
    });
});

$("#btAddDiskOK").on("click", function() {

    $('#addDiskForm input').each(function() {
        required(this);
    });

    if ($('#addDiskForm input.error').length != 0 || $('#addDiskForm select.error').length != 0)
        return false;

    $.ajax({
        url: '/api/clusterservers/' + CurServerId + '/backends',
        type: 'POST',
        contentType: "application/json",
        data: JSON.stringify({
            Initialize: 0,
            DiskPath: $('#addDiskDevice').val(),
            MountPath: $('#addDiskMountPath').val()
        }),
        dataType: 'JSON',
        success: function(data) {
            if (data.ReturnCode == 0) {
                showNics(CurServerId);
                $("#adddiskdismiss").click();
            } else {
                bootbox.alert({
                    buttons: {
                        ok: {
                            label: 'Failed',
                            className: 'btn-success'
                        }
                    },
                    message: "failed with status: " + data.ReturnCode,
                    callback: function() {}
                });
            }
        }
    }); //ajax

});

$(function() {

    var TargetId = 0;

    /**����༭**/
    $(document).on('click', "#editTarget", function() {

        if ($("input[name='ttt']:checked").length == 1) {

            //$('#editdomain').empty();
            $('#editTargetForm')[0].reset();

            //$('#tab2-1').find('input').removeClass('error').siblings('span.hint').css('display', 'none');
            //$("#edittab").trigger("click");
            TargetId = $("input[name='ttt']:checked").attr("data-id");




            $.each($('#tab2-2 input'), function() {
                $(this).blur(function() {
                    required(this);
                }).focus(function() {
                    isFocus(this);
                });
            });
            var dataID = $("input[name=ttt]:checked").attr("data-id");
            $.ajax({
                url: '/api/storageservers/' + CurServer + '/groups/' + dataID,
                type: 'GET',
                dataType: 'JSON',
                success: function(data) {
                    cout(data);

                    $("#editAccess").val(data.Access.toString());
                    $('#editGroupName').val(data.Name);
                }
            });
        } else {

            bootbox.alert({
                buttons: {
                    ok: {
                        label: 'ȷ��',
                        className: 'btn-success'
                    }
                },
                message: "��ѡ��һ�����ݣ�",
                callback: function() {

                }
            });
            return false;
        }

    });

    /**Clear Logs**/
    $(document).on('click', "#btClearLog", function() {

        bootbox.confirm({
            buttons: {
                cancel: {
                    label: 'Cancel',
                    className: 'btn-danger'
                },
                confirm: {
                    label: 'OK',
                    className: 'btn-success'
                }
            },
            message: "Are you confrim to clear all logs?",
            callback: function(result) {
                if (result) {
                    $.ajax({
                        url: '/api/clusterservers/' + CurServerId + '/logs/clear',
                        type: 'PUT',
                        dataType: 'JSON',
                        data: JSON.stringify({}),
                        contentType: "application/json",
                        success: function(data) {
                            if (data.ReturnCode != 0) {
                                countRes = 1;
                                bootbox.alert({
                                    buttons: {
                                        ok: {
                                            label: 'OK',
                                            className: 'btn-success'
                                        }
                                    },
                                    message: "Failed with status: " + data.ReturnCode,
                                    callback: function() {}
                                });
                            }
                        }
                    });

                    showLogs(CurServerId);
                }
            }
        });

    });

});