#/bin/sh

SERVICE=khttpd
TARGET=/opt/StorageCenter
PLATFORM=/etc/os-release

echo "Installing khttpd..."

if [ ! -d $TARGET ]
then
        mkdir -p $TARGET
fi

export PATH=$PATH:/sbin

num=0
if [ -f "/etc/init.d/$SERVICE" ]; then
        num=$(service $SERVICE status  | grep -v grep | grep running | wc -l)
fi

if [ $num -gt 0 ]
then
	echo "Stoping service $SERVICE..."
        service $SERVICE stop
fi

echo "Copying files..." 

cp *.so $TARGET/
cp khttp $TARGET/
#cp -u *.db $TARGET/
cp -u ca.pem $TARGET/
cp -ru html $TARGET/

echo "Setting up service..."

if [ -f /etc/system-release ]
then
PLATFORM=/etc/system-release
fi

if [ -n "$(grep 'CentOS' $PLATFORM)" ]
then
cp ./khttpd /etc/init.d/
chkconfig --add khttpd
cp khttpd $TARGET
elif [ -n "$(grep 'Ubuntu' $PLATFORM)" ]
then
cp ./khttpd /etc/init.d/khttpd
update-rc.d khttpd defaults
cp khttpd $TARGET/khttpd
else
echo "Invalid Platform."
fi

echo "Starting service..."

service $SERVICE start

echo "Finished."
